var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from "@angular/core";
import { Platform } from "ionic-angular";
const win = window;
let DBProvider = class DBProvider {
    constructor(dbName) {
        this.dbName = dbName;
        this.platform = new Platform();
        this._dbPromise = new Promise((resolve, reject) => {
            try {
                let _db;
                if (this.platform.is('cordova') && win.sqlitePlugin) {
                    //FOR MOBILE DEVICE
                    _db = win.sqlitePlugin.openDatabase({
                        name: this.dbName,
                        location: 'default'
                    });
                }
                else {
                    //FOR WEBSQL
                    console.warn('Storage: SQLite plugin not installed, falling back to WebSQL. Make sure to install cordova-sqlite-storage in production!');
                    _db = win.openDatabase(this.dbName, '1.0', 'database', 5 * 1024 * 1024);
                }
                resolve(_db);
            }
            catch (err) {
                reject({ err: err });
            }
        });
    }
    query(query, params = []) {
        return new Promise((resolve, reject) => {
            try {
                this._dbPromise.then(db => {
                    db.transaction((tx) => {
                        tx.executeSql(query, params, (tx, res) => resolve({ tx: tx, res: res }), (tx, err) => reject({ tx: tx, err: err }));
                    }, (err) => reject({ err: err }));
                });
            }
            catch (err) {
                reject({ err: err });
            }
        });
    }
};
DBProvider = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [String])
], DBProvider);
export { DBProvider };
//# sourceMappingURL=db-provider.js.map